image: cypress/browsers:node12.16.2-chrome81-ff75

services:
  - mysql:5.7

variables:
  MYSQL_DATABASE: $MYSQL_DB
  MYSQL_ROOT_PASSWORD: $MYSQL_PASS 
before_script:
  - chmod +x ./setup_env.sh
  - ./setup_env.sh
  - apt update && apt install mariadb-client -y
  - mysql --user="root" --password="$MYSQL_PASS" --host=mysql $MYSQL_DB < database.sql --default-character-set=utf8mb4

stages:
  - build
  - test

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_IID
    - if: $CI_COMMIT_TAG
    - if: $CI_COMMIT_BRANCH == "master" || $CI_COMMIT_BRANCH =~ /^2.[0-9]+\.x$/

test:
  stage: test
  script:
    - npm install
    - npm run start &
    - npm run runHeadless
  rules:
    - if: $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME !~ "master"
      changes:
        - views/*

build:
  stage: build
  script:
    - npm run install
  rules:
    - if: $CI_MERGE_REQUEST_SOURCE_BRANCH_NAME !~ "master"
      changes:
        - models/*
